# Search proposal history by ID

Use the **searchProposalHistoryById** method via JSON-RPC API 6.0 to find a specific proposal or retrieve the quote version history.

## Request parameters <a href="#request-parameters" id="request-parameters"></a>

<table><thead><tr><th width="171.33349609375">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>sessionId</code></td><td><p><strong>Required (string)</strong></p><p>Unique 2Checkout session ID code.</p></td></tr><tr><td><code>ProposalId</code></td><td><p><strong>Required (string)</strong></p><p>Proposal id.</p></td></tr><tr><td><code>Offset</code></td><td><p><strong>Required (integer)</strong></p><p>The offset at which the proposals should be returned. Default value: 0.</p></td></tr><tr><td><code>Limit</code></td><td><p><strong>Required (integer)</strong></p><p>The maximum number of proposal versions (history) to return. Default value: 10.</p></td></tr><tr><td><code>HasStatusComment</code></td><td><p><strong>Optional (string)</strong></p><p>Filters the history version by <code>statusComment</code> field. It can be “true” or “false”.</p></td></tr></tbody></table>

### Request sample

```php
<?php

declare(strict_types=1);

class Configuration
{
    public const MERCHANT_CODE = '';
    public const MERCHANT_KEY = '';
    public const URL = 'http://api.avangate.local/rpc/6.0';
    public const ACTION = 'searchProposalHistoryById';
    public const ADDITIONAL_OPTIONS = 'c0d6955b-f804-4a13-93a0-cb7cd04bc68a'; // existing proposal id
    //array or JSON
    public const PAYLOAD = <<<JSON
{
    "Limit": 10,
    "Offset": 0,
}
JSON;
}

class Client
{
    private const LOGIN_METHOD = 'login';
    private $calls = 1;
    private $sessionId;

    private function generateAuth(): array
    {
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $date = gmdate('Y-m-d H:i:s');
        $string = strlen($merchantCode) . $merchantCode . strlen($date) . $date;
        $hash = hash_hmac('md5', $string, $key);
        return compact('merchantCode', 'date', 'hash');
    }

    public function login(string $url)
    {
        $payload = $this->generateAuth();
        $response = $this->call($url, array_values($payload), self::LOGIN_METHOD);
        $this->sessionId = $response['result'];
    }

    public function call(
        string $url = Configuration::URL,
        $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION
    ): ?array
    {
        if (empty($this->sessionId) && $action !== self::LOGIN_METHOD) {
            $this->login($url);
        }
        if (is_string($payload)) {
            $payload = json_decode($payload, true);
        }
        if (!empty($this->sessionId)) {
            $payload = [$this->sessionId, Configuration::ADDITIONAL_OPTIONS, $payload];
        }
        $payload = array_filter($payload);
        $request = json_encode([
            'jsonrpc' => '2.0',
            'method' => $action,
            'params' => $payload,
            'id' => $this->calls++,
        ]);
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSLVERSION, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Accept: application/json', 'Cookie: XDEBUG_SESSION=PHPSTORM'));
        curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
        $response = curl_exec($curl);
        if (empty($response)) {
            die('Server unavailable');
        }
        echo $response . '</br>';
        return json_decode($response, true);;
    }
}

$client = new Client();
$result = $client->call();
var_dump($result);
```

## Response parameter <a href="#response" id="response"></a>

<table><thead><tr><th width="114.800048828125">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>Versions</code></td><td><p><strong>Object</strong></p><p>All versions of a proposal, paginated and ordered by date, newest first. Each element in the collection is a <a href="/pages/zGoQB6vtnyNTNd3gM09q"><code>Proposal</code></a> object.</p></td></tr><tr><td><code>Count</code></td><td><p><strong>Integer</strong></p><p>The total number of proposal versions.</p></td></tr><tr><td><code>Limit</code></td><td><p><strong>Integer</strong></p><p>The maximum number of proposal versions history to return. Default value: 10.</p></td></tr><tr><td><code>Offset</code></td><td><p><strong>Integer</strong></p><p>The offset at which the proposal versions history is returned.</p></td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/json-rpc-api-reference/json-rpc-api-6.0/api-requests/proposal-microservice/search-proposal-history-by-id.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
